//+------------------------------------------------------------------+
//|                             BrianIndexAve.mq4 (after BrianIndex) |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Silver
#property indicator_width1 3
#property indicator_color2 Silver
#property indicator_color3 Silver

/*#property indicator_color2 LimeGreen
#property indicator_color3 Yellow
#property indicator_color4 Orange
#property indicator_color5 OrangeRed
#property indicator_color6 Red
#property indicator_color7 DodgerBlue
#property indicator_color8 MediumBlue
#property indicator_color9 White*/

#property indicator_level1 0

double pair1[];
double pair2[];
double pair3[];
double pair4[];
double pair5[];
double pair6[];
double pair7[];
double pair8[];
double pairave[];
double max1[], max2[], max3[],max4[], max5[], max6[],max7[];
double min1[], min2[], min3[],min4[], min5[], min6[],min7[];

string TimeFrame_value = "TimeFrame(0,M5,M15,M30,H1,D1)";
string TimeFrame = "0";
string Display_Mode = "0=sum all, 1=separate";
int DisplayMode = 1;
bool DisplayMarkets = true;
string Broker_Time_Shift = "Broker server time shift";
int BrokerTimeShift = 0;
string Market_open_time = "Format(xx:xx-xx:xx)";
string LondonMarket = "08:00-17:00";
string NewYorkMarket = "13:00-22:00";
string SydneyMarket = "22:00-07:00";
string TokyoMarket = "00:00-09:00";
string CrossPair1 = "AUDJPY";
string CrossPair2 = "AUDUSD";
string CrossPair3 = "EURJPY";
string CrossPair4 = "EURUSD";
string CrossPair5 = "GBPJPY";
string CrossPair6 = "GBPUSD";
string CrossPair7 = "NZDJPY";
string CrossPair8 = "NZDUSD";
string PairAve = "PairAve";

int timeFrame = 0;
double pair1Close, pair2Close, pair3Close, pair4Close, pair5Close, pair6Close, pair7Close, pair8Close, pairaveClose;
int totalWeek = 0;
int lastDay = 0;
int MyWindow;

int LondonStartHour, LondonStartMin, LondonCloseHour, LondonCloseMin;
int NewYorkStartHour, NewYorkStartMin, NewYorkCloseHour, NewYorkCloseMin;
int SydneyStartHour, SydneyStartMin, SydneyCloseHour, SydneyCloseMin;
int TokyoStartHour, TokyoStartMin, TokyoCloseHour, TokyoCloseMin;

int init() {

   string short_name;

   IndicatorBuffers(3);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,pairave);
   SetIndexLabel(0,PairAve);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,max7);
   SetIndexLabel(1,"DDI2 max");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,min7);
   SetIndexLabel(2,"DDI2 min");
/*   SetIndexLabel(1,CrossPair2);
   SetIndexLabel(2,CrossPair3);
   SetIndexLabel(3,CrossPair4);
   SetIndexLabel(4,CrossPair5);
   SetIndexLabel(5,CrossPair6);
   SetIndexLabel(6,CrossPair7);
   SetIndexLabel(7,CrossPair8);
   SetIndexLabel(8,pairave);*/

   if (DisplayMode == 1) {

      SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, EMPTY, Silver);
      SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, EMPTY, Silver);
      SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, EMPTY, Silver);

   } else {
  
      SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, EMPTY, Silver);
      SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, EMPTY, Silver);
      SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, EMPTY, Silver);
/*      SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, EMPTY, LimeGreen);
      SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, EMPTY, Yellow);
      SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, EMPTY, Orange);
      SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, EMPTY, OrangeRed);
      SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, EMPTY, Red);
      SetIndexStyle(6, DRAW_LINE, STYLE_SOLID, EMPTY, DodgerBlue);
      SetIndexStyle(7, DRAW_LINE, STYLE_SOLID, EMPTY, MediumBlue);
      SetIndexStyle(8, DRAW_LINE, STYLE_SOLID, EMPTY, White);*/
      
   }

   if (TimeFrame == "M5") {

      timeFrame = PERIOD_M5;

   } else if (TimeFrame == "M15") {

      timeFrame = PERIOD_M15;

   } else if (TimeFrame == "M30") {

      timeFrame = PERIOD_M30;

   } else if (TimeFrame == "H1") {

      timeFrame = PERIOD_H1;

   } else if (TimeFrame == "D1") {

      timeFrame = PERIOD_D1;

   } else {

      timeFrame = 0;

   }

   LondonStartHour = StrToInteger(StringSubstr(LondonMarket, 0, 2))+BrokerTimeShift;
   LondonStartMin = StrToInteger(StringSubstr(LondonMarket, 3, 2));
   LondonCloseHour = StrToInteger(StringSubstr(LondonMarket, 6, 2))+BrokerTimeShift;
   LondonCloseMin = StrToInteger(StringSubstr(LondonMarket, 9, 2));

   NewYorkStartHour = StrToInteger(StringSubstr(NewYorkMarket, 0, 2))+BrokerTimeShift;
   NewYorkStartMin = StrToInteger(StringSubstr(NewYorkMarket, 3, 2));
   NewYorkCloseHour = StrToInteger(StringSubstr(NewYorkMarket, 6, 2))+BrokerTimeShift;
   NewYorkCloseMin = StrToInteger(StringSubstr(NewYorkMarket, 9, 2));

   SydneyStartHour = StrToInteger(StringSubstr(SydneyMarket, 0, 2))+BrokerTimeShift;
   SydneyStartMin = StrToInteger(StringSubstr(SydneyMarket, 3, 2));
   SydneyCloseHour = StrToInteger(StringSubstr(SydneyMarket, 6, 2))+BrokerTimeShift;
   SydneyCloseMin = StrToInteger(StringSubstr(SydneyMarket, 9, 2));

   TokyoStartHour = StrToInteger(StringSubstr(TokyoMarket, 0, 2))+BrokerTimeShift;
   TokyoStartMin = StrToInteger(StringSubstr(TokyoMarket, 3, 2));
   TokyoCloseHour = StrToInteger(StringSubstr(TokyoMarket, 6, 2))+BrokerTimeShift;
   TokyoCloseMin = StrToInteger(StringSubstr(TokyoMarket, 9, 2));

   return(0);

}

int deinit() {

   ObjectsDeleteAll(0, OBJ_VLINE);

   return(0);
}

int start() {

   int i, counted_bars = IndicatorCounted();
   i = Bars - counted_bars - 1;

   while (i >= 0) {

      if (DisplayMarkets && timeFrame != PERIOD_D1) {

         setSessionLine(i);
         
      }

      
      int timeFrameIndex = iBarShift(0, timeFrame, Time[i], true);

      if ((TimeDayOfWeek(iTime(NULL, timeFrame, timeFrameIndex)) == 1 && TimeDayOfWeek(iTime(NULL, timeFrame, timeFrameIndex+1)) == 5) ||
       (TimeDayOfWeek(iTime(NULL, timeFrame, timeFrameIndex)) == 0 && TimeDayOfWeek(iTime(NULL, timeFrame, timeFrameIndex+1)) == 5)){
//      if ((TimeDayOfWeek(iTime(NULL, timeFrame, timeFrameIndex)) == 3 && TimeDayOfWeek(iTime(NULL, timeFrame, timeFrameIndex+1)) == 2)){

         pair1Close = iClose(CrossPair1, timeFrame, timeFrameIndex+1);
         pair2Close = iClose(CrossPair2, timeFrame, timeFrameIndex+1);
         pair3Close = iClose(CrossPair3, timeFrame, timeFrameIndex+1);
         pair4Close = iClose(CrossPair4, timeFrame, timeFrameIndex+1);
         pair5Close = iClose(CrossPair5, timeFrame, timeFrameIndex+1);
         pair6Close = iClose(CrossPair6, timeFrame, timeFrameIndex+1);
         pair7Close = iClose(CrossPair7, timeFrame, timeFrameIndex+1);
         pair8Close = iClose(CrossPair8, timeFrame, timeFrameIndex+1);

      }
/*      Print("pair1Close=", pair1Close);
      Print("pair2Close=", pair2Close);
      Print("pair3Close=", pair3Close);
      Print("pair4Close=", pair4Close);
      Print("pair5Close=", pair5Close);
      Print("pair6Close=", pair6Close);
      Print("pair7Close=", pair7Close);
      Print("pair8Close=", pair8Close);*/

      if (pair1Close > 0 && pair2Close > 0 &&
          pair3Close > 0 && pair4Close > 0 &&
          pair5Close > 0 && pair6Close > 0 &&
          pair7Close > 0 && pair8Close > 0 &&
          TimeDayOfWeek(iTime(NULL, timeFrame, i)) > 0) {
          
          if (lastDay != TimeDayOfWeek(iTime(NULL, timeFrame, i))) {
//Print("totalDayOfWeek(", lastDay, ")=", totalWeek);

            lastDay = TimeDayOfWeek(iTime(NULL, timeFrame, i));
            totalWeek = 0;
          }
         
         pairave[i] = 0;
         
            pair1[i] = (iClose(CrossPair1, timeFrame, i) - pair1Close)/MarketInfo(CrossPair1,MODE_POINT);
            pair2[i] = (iClose(CrossPair2, timeFrame, i) - pair2Close)/MarketInfo(CrossPair2,MODE_POINT);
            pair3[i] = (iClose(CrossPair3, timeFrame, i) - pair3Close)/MarketInfo(CrossPair3,MODE_POINT);
            pair4[i] = (iClose(CrossPair4, timeFrame, i) - pair4Close)/MarketInfo(CrossPair4,MODE_POINT);
            pair5[i] = (iClose(CrossPair5, timeFrame, i) - pair5Close)/MarketInfo(CrossPair5,MODE_POINT);
            pair6[i] = (iClose(CrossPair6, timeFrame, i) - pair6Close)/MarketInfo(CrossPair6,MODE_POINT);
            pair7[i] = (iClose(CrossPair7, timeFrame, i) - pair7Close)/MarketInfo(CrossPair7,MODE_POINT);
            pair8[i] = (iClose(CrossPair8, timeFrame, i) - pair8Close)/MarketInfo(CrossPair8,MODE_POINT);
            max1[i] = MathMax(pair1[i],pair2[i]);
            max2[i] = MathMax(pair3[i],pair4[i]);
            max3[i] = MathMax(pair5[i],pair6[i]);
            max4[i] = MathMax(pair7[i],pair8[i]);
            max5[i] = MathMax(max1[i],max2[i]);
            max6[i] = MathMax(max3[i],max4[i]);
            max7[i] = MathMax(max5[i],max6[i]);
            min1[i] = MathMin(pair1[i],pair2[i]);
            min2[i] = MathMin(pair3[i],pair4[i]);
            min3[i] = MathMin(pair5[i],pair6[i]);
            min4[i] = MathMin(pair7[i],pair8[i]);
            min5[i] = MathMin(min1[i],min2[i]);
            min6[i] = MathMin(min3[i],min4[i]);
            min7[i] = MathMin(min5[i],min6[i]);
            min7[i] = WindowPriceMin(WindowOnDropped());
            max7[i] = WindowPriceMax(WindowOnDropped());
            
            pairave[i] = (iClose(CrossPair1, timeFrame, i) - pair1Close)/MarketInfo(CrossPair1,MODE_POINT) +
                         ((iClose(CrossPair2, timeFrame, i) - pair2Close)/MarketInfo(CrossPair2,MODE_POINT)) +
                         ((iClose(CrossPair3, timeFrame, i) - pair3Close)/MarketInfo(CrossPair3,MODE_POINT)) +
                         ((iClose(CrossPair4, timeFrame, i) - pair4Close)/MarketInfo(CrossPair4,MODE_POINT)) +
                         ((iClose(CrossPair5, timeFrame, i) - pair5Close)/MarketInfo(CrossPair5,MODE_POINT)) +
                         ((iClose(CrossPair6, timeFrame, i) - pair6Close)/MarketInfo(CrossPair6,MODE_POINT)) +
                         ((iClose(CrossPair7, timeFrame, i) - pair7Close)/MarketInfo(CrossPair7,MODE_POINT)) +
                         ((iClose(CrossPair8, timeFrame, i) - pair8Close)/MarketInfo(CrossPair8,MODE_POINT));
            pairave[i] = pairave[i]/8;
         //Print("pairave[",i, "]=", pairave[i]);
         //totalWeek = totalWeek + pair8[i];
      } 

      i--;

   }
   WindowRedraw();
   return(0);
}

string formatInteger(int value) {

   if (value < 10) {
   
      return("0" + value);
   
   } else {
   
      return("" + value);
   
   }

}

int setSessionLine(int i) {

      if (TimeHour(iTime(NULL, timeFrame, i)) == LondonStartHour && TimeMinute(iTime(NULL, timeFrame, i)) == LondonStartMin) {

          ObjectDelete("London Open " + formatInteger(LondonStartHour) + ":" + formatInteger(LondonStartMin));
          ObjectCreate("London Open " + formatInteger(LondonStartHour) + ":" + formatInteger(LondonStartMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("London Open " + formatInteger(LondonStartHour) + ":" + formatInteger(LondonStartMin), OBJPROP_COLOR, LimeGreen);
          ObjectSet("London Open " + formatInteger(LondonStartHour) + ":" + formatInteger(LondonStartMin), OBJPROP_STYLE, STYLE_DOT);
          
      } else if (TimeHour(iTime(NULL, timeFrame, i)) == LondonCloseHour && TimeMinute(iTime(NULL, timeFrame, i)) == LondonCloseMin) {

          ObjectDelete("London Close " + formatInteger(LondonCloseHour) + ":" + formatInteger(LondonCloseMin));
          ObjectCreate("London Close " + formatInteger(LondonCloseHour) + ":" + formatInteger(LondonCloseMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("London Close " + formatInteger(LondonCloseHour) + ":" + formatInteger(LondonCloseMin), OBJPROP_COLOR, LimeGreen);
          ObjectSet("London Close " + formatInteger(LondonCloseHour) + ":" + formatInteger(LondonCloseMin), OBJPROP_STYLE, STYLE_DOT);

      }
      if (TimeHour(iTime(NULL, timeFrame, i)) == NewYorkStartHour && TimeMinute(iTime(NULL, timeFrame, i)) == NewYorkStartMin) {

          ObjectDelete("NewYork Open " + formatInteger(NewYorkStartHour) + ":" + formatInteger(NewYorkStartMin));
          ObjectCreate("NewYork Open " + formatInteger(NewYorkStartHour) + ":" + formatInteger(NewYorkStartMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("NewYork Open " + formatInteger(NewYorkStartHour) + ":" + formatInteger(NewYorkStartMin), OBJPROP_COLOR, Orange);
          ObjectSet("NewYork Open " + formatInteger(NewYorkStartHour) + ":" + formatInteger(NewYorkStartMin), OBJPROP_STYLE, STYLE_DOT);
      
      } else if (TimeHour(iTime(NULL, timeFrame, i)) == NewYorkCloseHour && TimeMinute(iTime(NULL, timeFrame, i)) == NewYorkCloseMin) {

          ObjectDelete("NewYork Close " + formatInteger(NewYorkCloseHour) + ":" + formatInteger(NewYorkCloseMin));
          ObjectCreate("NewYork Close " + formatInteger(NewYorkCloseHour) + ":" + formatInteger(NewYorkCloseMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("NewYork Close " + formatInteger(NewYorkCloseHour) + ":" + formatInteger(NewYorkCloseMin), OBJPROP_COLOR, Orange);
          ObjectSet("NewYork Close " + formatInteger(NewYorkCloseHour) + ":" + formatInteger(NewYorkCloseMin), OBJPROP_STYLE, STYLE_DOT);

      }
      if (TimeHour(iTime(NULL, timeFrame, i)) == SydneyStartHour && TimeMinute(iTime(NULL, timeFrame, i)) == SydneyStartMin) {

          ObjectDelete("Sydney Open " + formatInteger(SydneyStartHour) + ":" + formatInteger(SydneyStartMin));
          ObjectCreate("Sydney Open " + formatInteger(SydneyStartHour) + ":" + formatInteger(SydneyStartMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("Sydney Open " + formatInteger(SydneyStartHour) + ":" + formatInteger(SydneyStartMin), OBJPROP_COLOR, DodgerBlue);
          ObjectSet("Sydney Open " + formatInteger(SydneyStartHour) + ":" + formatInteger(SydneyStartMin), OBJPROP_STYLE, STYLE_DOT);
      
      } else if (TimeHour(iTime(NULL, timeFrame, i)) == SydneyCloseHour && TimeMinute(iTime(NULL, timeFrame, i)) == SydneyCloseMin) {

          ObjectDelete("Sydney Close " + formatInteger(SydneyCloseHour) + ":" + formatInteger(SydneyCloseMin));
          ObjectCreate("Sydney Close " + formatInteger(SydneyCloseHour) + ":" + formatInteger(SydneyCloseMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("Sydney Close " + formatInteger(SydneyCloseHour) + ":" + formatInteger(SydneyCloseMin), OBJPROP_COLOR, DodgerBlue);
          ObjectSet("Sydney Close " + formatInteger(SydneyCloseHour) + ":" + formatInteger(SydneyCloseMin), OBJPROP_STYLE, STYLE_DOT);

      }
      if (TimeHour(iTime(NULL, timeFrame, i)) == TokyoStartHour && TimeMinute(iTime(NULL, timeFrame, i)) == TokyoStartMin) {

          ObjectDelete("Tokyo Open " + formatInteger(TokyoStartHour) + ":" + formatInteger(TokyoStartMin));
          ObjectCreate("Tokyo Open " + formatInteger(TokyoStartHour) + ":" + formatInteger(TokyoStartMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("Tokyo Open " + formatInteger(TokyoStartHour) + ":" + formatInteger(TokyoStartMin), OBJPROP_COLOR, Yellow);
          ObjectSet("Tokyo Open " + formatInteger(TokyoStartHour) + ":" + formatInteger(TokyoStartMin), OBJPROP_STYLE, STYLE_DOT);
      
      } else if (TimeHour(iTime(NULL, timeFrame, i)) == TokyoCloseHour && TimeMinute(iTime(NULL, timeFrame, i)) == TokyoCloseMin) {

          ObjectDelete("Tokyo Close " + formatInteger(TokyoCloseHour) + ":" + formatInteger(TokyoCloseMin));
          ObjectCreate("Tokyo Close " + formatInteger(TokyoCloseHour) + ":" + formatInteger(TokyoCloseMin), OBJ_VLINE, 0, iTime(NULL, timeFrame, i), 0);
          ObjectSet("Tokyo Close " + formatInteger(TokyoCloseHour) + ":" + formatInteger(TokyoCloseMin), OBJPROP_COLOR, Yellow);
          ObjectSet("Tokyo Close " + formatInteger(TokyoCloseHour) + ":" + formatInteger(TokyoCloseMin), OBJPROP_STYLE, STYLE_DOT);

      }

}


//+------------------------------------------------------------------+